
// SCPI_TESTDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "SCPI_TEST.h"
#include "SCPI_TESTDlg.h"
#include <vector>
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define WM_UPSTATE WM_USER + 111

using namespace SCPICOMM;

#define IPADDR		"192.168.4.252"
#define SOCKET_PORT	34434

namespace
{
	int paudRate[] = 
	{
		CBR_110,
		CBR_300,
		CBR_600,
		CBR_1200,
		CBR_2400,
		CBR_4800,
		CBR_9600,
		CBR_14400,
		CBR_19200,
		CBR_38400,
		CBR_56000,
		CBR_57600,
		CBR_115200,
		CBR_128000,
		CBR_256000,
	};

	CString gpibTimeOut[] =
	{
		_T("none"),
		_T("10us"),
		_T("30us"),
		_T("100us"),
		_T("300us"),
		_T("1ms"),
		_T("3ms"),
		_T("10ms"),
		_T("30ms"),
		_T("100ms"),
		_T("300ms"),
		_T("1s"),
		_T("3s"),
		_T("10s"),
		_T("30s"),
		_T("100s"),
		_T("300s"),
		_T("1000s"),
	};

	/*ֽڴתΪUnicodeַ*/
	std::wstring MBCS2Unicode(LPCSTR str)
	{
		if (str==NULL)	return L"";

		int nLen = strlen(str) * 2 + 2;
		WCHAR * pNewStr = new WCHAR[nLen];
		memset(pNewStr, 0, nLen);

		MultiByteToWideChar(CP_ACP, 0, str, -1, pNewStr, nLen);

		std::wstring strRet = pNewStr;
		delete [] pNewStr;
		return strRet;
	}

	/*UnicodeַתΪֽڴ*/
	std::string Unicode2MBCS(LPCWSTR wstr)
	{
		if (wstr == NULL)		return "";
		BOOL bUsedDefaultChar = FALSE;
		int size = WideCharToMultiByte(CP_ACP, 0, wstr, -1, NULL, 0, NULL, &bUsedDefaultChar);

		if ( size <= 0 )	return "";

		char * pNewStr = (char*)malloc(size + 1);
		memset(pNewStr,0,size);

		WideCharToMultiByte(CP_ACP, 0, wstr, -1, pNewStr, size, NULL, &bUsedDefaultChar);

		std::string strRet = pNewStr;
		free(pNewStr);
		return strRet;
	}

}

// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSCPI_TESTDlg Ի




CSCPI_TESTDlg::CSCPI_TESTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSCPI_TESTDlg::IDD, pParent),
	m_scpiHandle(NULL),m_pScpi(NULL)
	, m_sendString(_T("")),m_connectType(LAN_COMM)
	, m_recvString(_T("")),m_hModule(NULL)
	, m_getdataLen(0),m_sendCommand(FALSE)
	, m_ipPort(SOCKET_PORT),m_threadHandle(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CSCPI_TESTDlg::~CSCPI_TESTDlg()
{
	if (m_threadHandle)
	{
		CloseHandle(m_threadHandle);
		m_threadHandle = NULL;
	}

    if (m_pScpi)
    {
        m_pScpi->Release(m_scpiHandle);
		delete m_pScpi;
		m_pScpi = NULL;
    }

	if (m_hModule)
	{
		FreeLibrary(m_hModule);
		m_hModule = NULL;
	}
}

void CSCPI_TESTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IPADDRESS1, m_ipAddress);
	DDX_Text(pDX, IDC_SENDDATA, m_sendString);
	DDX_Text(pDX, IDC_RECVDATA, m_recvString);
	DDX_Text(pDX, IDC_GETDATALEN, m_getdataLen);
	DDX_Control(pDX, IDC_RS232_COM, m_comNum);
	DDX_Control(pDX, IDC_RS232_BAUNDRATE, m_boaudRate);
	DDX_Control(pDX, IDC_RS232_BYTESIZE, m_byteSize);
	DDX_Control(pDX, IDC_RS232_PARITY, m_parity);
	DDX_Control(pDX, IDC_RS232_STOPBITS, m_stopBits);
	DDX_Text(pDX, IDC_IPPORT, m_ipPort);
	DDX_Control(pDX, IDC_GPIB_BOARD, m_gpibBoard);
	DDX_Control(pDX, IDC_GPIB_PRIADDR, m_gpibPriAddr);
	DDX_Control(pDX, IDC_GPIB_SECADDR, m_gpibSecAddr);
	DDX_Control(pDX, IDC_GPIB_TIMEOUT, m_gpibTimeout);
	DDX_Control(pDX, IDC_GPIB_EOT, m_gpibEot);
	DDX_Control(pDX, IDC_GPIB_EOS, m_gpibEos);
	DDX_Control(pDX, IDC_DEV_COMBOX, m_devTypeComm);
}

BEGIN_MESSAGE_MAP(CSCPI_TESTDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_IP, &CSCPI_TESTDlg::OnBnClickedIp)
	ON_BN_CLICKED(IDC_GPIB, &CSCPI_TESTDlg::OnBnClickedGpib)
	ON_BN_CLICKED(IDC_RS232, &CSCPI_TESTDlg::OnBnClickedRS232)
	ON_BN_CLICKED(IDC_USB, &CSCPI_TESTDlg::OnBnClickedUSB)
	ON_BN_CLICKED(IDCANCEL, &CSCPI_TESTDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_CONNECT, &CSCPI_TESTDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_SEND, &CSCPI_TESTDlg::OnBnClickedSend)
	ON_BN_CLICKED(IDC_CLOSECONNECT, &CSCPI_TESTDlg::OnBnClickedCloseconnect)
	ON_BN_CLICKED(IDC_CLEARMSG, &CSCPI_TESTDlg::OnBnClickedClearMsg)
	ON_MESSAGE(WM_UPSTATE, &CSCPI_TESTDlg::SetState)
END_MESSAGE_MAP()


// CSCPI_TESTDlg Ϣ

BOOL CSCPI_TESTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
		
	InitCtrl();
	LoadDll();

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CSCPI_TESTDlg::LoadDll()
{
	m_hModule = LoadLibrary(L"SCPIComm.dll");
	typedef BOOL (*CREATESCPI)(SCPIInterface **);

	if(m_hModule != NULL)
	{
		m_pScpi = new SCPIInterface;
		CREATESCPI CreateScpi = (CREATESCPI)GetProcAddress(m_hModule, "GetInterface");
		if (CreateScpi != NULL)
		{
			if (!(*CreateScpi)(&m_pScpi) )
			{
				MessageBox(_T("ͨͨŶʧ!"), _T("ʾ"), MB_OK);
				return;
			}
			m_scpiHandle = m_pScpi->CreateObject();
		}
	}
	else MessageBox(_T("ض̬ʧܣȱSCPIComm.dll!"), _T("ʾ"), MB_OK);
}

void CSCPI_TESTDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CSCPI_TESTDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CSCPI_TESTDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSCPI_TESTDlg::InitCtrl()
{
	int index = 0;
	CString str;

	/*豸*/
	m_devTypeComm.AddString(_T("PA") );
	m_devTypeComm.AddString(_T("PM") );
	m_devTypeComm.AddString(_T("ZDL7000") );
	m_devTypeComm.AddString(_T("DX2048") );
    m_devTypeComm.AddString(_T("GX20") );
	m_devTypeComm.SetCurSel(4);

	/*̫ͨſؼ*/
	m_ipAddress.SetFieldRange(0, 0, 254);
	m_ipAddress.SetFieldRange(1, 0, 254);
	m_ipAddress.SetFieldRange(2, 0, 254);
	m_ipAddress.SetFieldRange(3, 0, 254);

	m_ipAddress.SetAddress(htonl(inet_addr(IPADDR) ) );
    

	/*GPIBͨſؼ*/
	for (index = 0; index < 31; ++index)
	{
		str.Format(_T("GPIB%d"), index);
		m_gpibBoard.AddString(str);
		str.Format(_T("%d"), index);
		m_gpibPriAddr.AddString(str);
		m_gpibSecAddr.AddString(str);
	}
	m_gpibBoard.SetCurSel(0);
	m_gpibPriAddr.SetCurSel(2);
	m_gpibSecAddr.SetCurSel(0);

	int size = sizeof(gpibTimeOut) / sizeof(gpibTimeOut[0]);
	for (index = 0; index < size; ++index)
	{
		m_gpibTimeout.AddString(gpibTimeOut[index]);
	}
	m_gpibTimeout.SetCurSel(13);

	for (index = 0; index < 2; ++index)
	{
		str.Format(_T("%d"), index);
		m_gpibEot.AddString(str);
		m_gpibEos.AddString(str);
	}
	m_gpibEot.SetCurSel(1);
	m_gpibEos.SetCurSel(0);


	/*RS232ͨſؼ*/
	for (index = 1; index <= 30; ++index)
	{
		str.Format(_T("COM%d") , index);
		m_comNum.AddString(str);
	}
	m_comNum.SetCurSel(0);
	
	size = sizeof(paudRate) / sizeof(paudRate[0]);
	for (index = 0; index < size; ++index)
	{
		str.Format(_T("%d"), paudRate[index] );
		m_boaudRate.AddString(str);
	}
	m_boaudRate.SetCurSel(12);

	for (index = 5; index < 9; ++index)
	{
		str.Format(_T("%d"), index);
		m_byteSize.AddString(str);
	}
	m_byteSize.SetCurSel(3);
	
	m_parity.AddString(_T("NONE") );
	m_parity.AddString(_T("ODD") );
	m_parity.AddString(_T("EVEN") );
	m_parity.AddString(_T("MARK") );
	m_parity.AddString(_T("SPACE") );
	m_parity.SetCurSel(0);

	m_stopBits.AddString(_T("1") );
	m_stopBits.AddString(_T("1.5") );
	m_stopBits.AddString(_T("2") );
	m_stopBits.SetCurSel(0);
	
	/*USBͨſؼ*/


	/*״̬*/
	((CWnd *)GetDlgItem(IDC_CLOSECONNECT))->EnableWindow(FALSE);
	((CWnd *)GetDlgItem(IDC_SEND))->EnableWindow(FALSE);
	m_sendString = _T("*IDN?");
	SetConnectBtnState(IDC_IP);
    UpdateData(FALSE);
}

void CSCPI_TESTDlg::OnClose()
{
	if (m_pScpi)
	{
		m_pScpi->Close(m_scpiHandle);
	}

    CDialog::OnClose();
}

void CSCPI_TESTDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnClose();
	CDialog::OnCancel();
}

void CSCPI_TESTDlg::SetBtnIPState(BOOL flag)
{
	((CButton *)GetDlgItem(IDC_IP) )->SetCheck(flag);
	int state = SW_HIDE;
	if (flag)
	{
		state = SW_SHOW;
	}
	((CWnd *)GetDlgItem(IDC_IPADDR))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_IPADDR))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_IPPORT))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_IPPORT))->ShowWindow(state);
}


void CSCPI_TESTDlg::SetBtnGPIBState(BOOL flag)
{
	((CButton *)GetDlgItem(IDC_GPIB) )->SetCheck(flag);
	int state = SW_HIDE;
	if (flag)
	{
		state = SW_SHOW;
	}
	((CWnd *)GetDlgItem(IDC_GPIB_BOARD))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_BOARD))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_GPIB_PRIADDR))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_PRIADDR))->ShowWindow(state);
	
	((CWnd *)GetDlgItem(IDC_GPIB_SECADDR))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_SECADDR))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_GPIB_TIMEOUT))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_TIMEOUT))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_GPIB_EOT))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_EOT))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_GPIB_EOS))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_EOS))->ShowWindow(state);

}

void CSCPI_TESTDlg::SetBtnRS232State(BOOL flag)
{
	((CButton *)GetDlgItem(IDC_RS232) )->SetCheck(flag);
	int state = SW_HIDE;
	if (flag)
	{
		state = SW_SHOW;
	}

	((CWnd *)GetDlgItem(IDC_RS232_COM))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_COM))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_RS232_BAUNDRATE))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_RATE))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_RS232_BYTESIZE))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_DATABITS))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_RS232_PARITY))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_PRITY))->ShowWindow(state);

	((CWnd *)GetDlgItem(IDC_RS232_STOPBITS))->ShowWindow(state);
	((CWnd *)GetDlgItem(IDC_STATIC_STOPBITS))->ShowWindow(state);
}

void CSCPI_TESTDlg::SetBtnUSBState(BOOL flag)
{
	((CButton *)GetDlgItem(IDC_USB) )->SetCheck(flag);
}

void CSCPI_TESTDlg::SetConnectBtnState(UINT nID)
{
	BOOL state[4] ={FALSE};
	switch (nID)
	{
	case IDC_IP:
		{
			state[0] = TRUE;
		}
		break;
	case IDC_GPIB:
		{
			state[1] = TRUE;
		}
		break;
	case IDC_RS232:
		{
			state[2] = TRUE;
		}
		break;
	case IDC_USB:
		{
			state[3] = TRUE;
		}
		break;
	}
	SetBtnIPState(state[0]);
	SetBtnGPIBState(state[1]);
	SetBtnRS232State(state[2]);
	SetBtnUSBState(state[3]);
}

void CSCPI_TESTDlg::OnBnClickedIp()
{
	// TODO: Add your control notification handler code here
    m_connectType = LAN_COMM;
	SetConnectBtnState(IDC_IP);
}

void CSCPI_TESTDlg::OnBnClickedGpib()
{
	// TODO: Add your control notification handler code here
    m_connectType = GPIB_COMM;
	SetConnectBtnState(IDC_GPIB);
}

void CSCPI_TESTDlg::OnBnClickedRS232()
{
	// TODO: Add your control notification handler code here
	m_connectType = RS232_COMM;
	SetConnectBtnState(IDC_RS232);
}

void CSCPI_TESTDlg::OnBnClickedUSB()
{
	// TODO: Add your control notification handler code here

	m_connectType = USB_COMM;
	SetConnectBtnState(IDC_USB);
}

DWORD CSCPI_TESTDlg::GetDataThread(void *pParam)
{
    /*
        devType 豸ͣ0 PA; 1 PM; 2 ZDL7000; 3 DX8720P
    */
	CSCPI_TESTDlg * pThis = (CSCPI_TESTDlg *)(pParam);
	
	pThis->m_getdataLen = 0;

	bool require = true;

    /*ָ*/
	std::string sendString = Unicode2MBCS(pThis->m_sendString.GetBuffer() );
	pThis->m_sendString.ReleaseBuffer();
	
	int sendLen = sendString.length();
	int devType = pThis->m_devTypeComm.GetCurSel();
	if ( devType != 2)
	{
		if (std::string::npos == sendString.find('?') && devType != 3)
		{
			require = false;
		}
	}
	else if (devType == 2)
	{
		if (std::string::npos == sendString.find(":qurey") )
		{
			require = false;
		}
	}

	/*
	/*	PAַ";" 
    /*  PMDX2048Pַ"\n"
    /*  GX20ַ"\r\n"
	*/

	if (devType == 0)
	{
        sendString += ";";
	}
	else if (devType == 1 || devType == 3)
	{
       sendString += "\n";
	}
    else if (devType == 4)
    { 
        sendString += "\r\n";
        require = true;
    }

	char *recvBuff = new char[4096 * 10];
	int recvLen = 40960;
	int ret = pThis->m_pScpi->SendAndGetResponse(	pThis->m_scpiHandle, 
													sendString.c_str(), 
													sendString.length(), 
													require, 
													recvBuff,
													&recvLen,
													DT_SERIAL);

	if (EC_NET_ERR ==  ret)
    {
        pThis->MessageBox(_T("ָʧ,ѶϿ!"), _T("ʾ"), MB_OK);
    }
	else if (EC_NET_TIME_OUT == ret)
	{
		pThis->MessageBox(_T("ָʧ,緢ͳʱ!"), _T("ʾ"), MB_OK);
	}
	else if (EC_FAILURE ==  ret)
	{
		pThis->MessageBox(_T("ʧ,ѶϿָЧ!"), _T("ʾ"), MB_OK);
		pThis->m_recvString = _T("ʧ");
	}
	else if (EC_INSUFFICIENT_BUFFER_ERROR == ret)
	{
		pThis->MessageBox(_T("ܻ"), _T("ʾ"), MB_OK);
	}

	if (ret == EC_SUCCESS)
	{
		if (require == true)
		{
			recvBuff[recvLen - 1] = '\0';
			std::wstring recvString = MBCS2Unicode(recvBuff);
			pThis->m_recvString = recvString.c_str();
			pThis->m_getdataLen = pThis->m_recvString.GetLength();
		}
	}

	::PostMessage(pThis->GetSafeHwnd(), WM_UPSTATE, 0, 0);
	delete []recvBuff;
	return 0;
}

HRESULT CSCPI_TESTDlg::SetState(WPARAM wParam, LPARAM lParam)
{
	CloseHandle(m_threadHandle);
	m_threadHandle = NULL;
	m_sendCommand = FALSE;
	UpdateData(FALSE);
	return 0;
}

void CSCPI_TESTDlg::OnBnClickedConnect()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int res = EC_FAILURE;
	if (m_pScpi != NULL)
	{
		if (m_connectType == LAN_COMM)
		{
			unsigned long  ipAddress;
			m_ipAddress.GetAddress(ipAddress);
			in_addr inAddr;
			inAddr.S_un.S_addr		 = htonl(ipAddress);
			std::string ipStr		 = inet_ntoa(inAddr);
			//std::wstring ipAddrString = MBCS2Unicode(ipStr.c_str() );
			LanCommArg arg = {ipStr, m_ipPort};
			res = m_pScpi->Open(m_scpiHandle, LAN_COMM, &arg);

		} 
		else if(m_connectType == GPIB_COMM)
		{
			GpibCommArg arg = { m_gpibBoard.GetCurSel(), 
				m_gpibPriAddr.GetCurSel(), 
				m_gpibSecAddr.GetCurSel(), 
				static_cast<GPIB_TIME_OUT>(m_gpibTimeout.GetCurSel() ), 
				m_gpibEot.GetCurSel(), 
				m_gpibEos.GetCurSel()};
			res = m_pScpi->Open(m_scpiHandle, GPIB_COMM, &arg);
		}
		else if (m_connectType == RS232_COMM)
		{
			RS232CommArg arg = {m_comNum.GetCurSel() + 1, 
				paudRate[m_boaudRate.GetCurSel()],
				m_byteSize.GetCurSel() + 5, 
				m_parity.GetCurSel(), 
				m_stopBits.GetCurSel(),
				RS232_NO_C};
			res = m_pScpi->Open(m_scpiHandle, RS232_COMM, &arg);
		}
		else if (m_connectType == USB_COMM)
		{
			res = m_pScpi->Open(m_scpiHandle, USB_COMM, NULL);
		}

		if (res == EC_OBJECT_ERROR)
		{
			//	MessageBox(_T("δɹ!"), _T("ʾ"), MB_OK);
		}
		else if (res == EC_FAILURE || res == EC_NET_ERR)
		{
			//	MessageBox(_T("δӳɹ!"), _T("ʾ"), MB_OK);
		}
		else
		{
			SetBntStates(FALSE);
		}
	}
}

void CSCPI_TESTDlg::OnBnClickedSend()
{
	// TODO: Add your control notification handler code here
    UpdateData(TRUE);
	m_recvString = _T("");
	m_getdataLen = 0;
	SetDlgItemText(IDC_RECVDATA, m_recvString);
	if (m_pScpi == NULL)
	{
		MessageBox(_T("δɹ,ʧ!"), _T("ʾ"), MB_OK);
		return ;
	}
	if (m_sendCommand)
	{
		MessageBox(_T("ڱ,ָʧ!"), _T("ʾ"), MB_OK);
		return ;
	}
	m_threadHandle = CreateThread(NULL, 0, GetDataThread, this, 0, NULL);
	if (m_threadHandle != NULL)
	{
		m_sendCommand = TRUE;
	}
}

void CSCPI_TESTDlg::OnBnClickedCloseconnect()
{
	// TODO: Add your control notification handler code here
	if (m_pScpi && m_scpiHandle)
	{
		 m_pScpi->Close(m_scpiHandle);
	}

	SetBntStates(TRUE);

	if (m_threadHandle)
	{
		CloseHandle(m_threadHandle);
		m_threadHandle = NULL;
	}
	m_sendCommand = FALSE;
}

void CSCPI_TESTDlg::OnBnClickedClearMsg()
{
	m_recvString = _T("");
	m_getdataLen = 0;
	SetDlgItemText(IDC_RECVDATA, m_recvString);
	SetDlgItemText(IDC_GETDATALEN, _T("0") );
}


void CSCPI_TESTDlg::SetBntStates(BOOL flag)
{

    ((CWnd *)GetDlgItem(IDC_CONNECT))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_IP))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_GPIB))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_RS232))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_USB))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_DEV_COMBOX))->EnableWindow(flag);

    ((CWnd *)GetDlgItem(IDC_IPADDRESS1))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_RS232_COM))->EnableWindow(flag);

    ((CWnd *)GetDlgItem(IDC_RS232_BAUNDRATE))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_RS232_BYTESIZE))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_RS232_PARITY))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_RS232_STOPBITS))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_IPPORT))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_GPIB_BOARD))->EnableWindow(flag);
    ((CWnd *)GetDlgItem( IDC_GPIB_PRIADDR))->EnableWindow(flag);
    ((CWnd *)GetDlgItem( IDC_GPIB_SECADDR))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_GPIB_TIMEOUT))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_GPIB_EOT))->EnableWindow(flag);
    ((CWnd *)GetDlgItem(IDC_GPIB_EOS))->EnableWindow(flag);


    ((CWnd *)GetDlgItem(IDC_SEND))->EnableWindow(!flag);
    ((CWnd *)GetDlgItem(IDC_CLOSECONNECT))->EnableWindow(!flag);
}